c0de21f53d55e811377582495099e5a7e0466e77
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=1.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################
29 # Local Machine Settings:
30 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
31 # and the local conf file created by each local machine (rip_dvd.conf)
32 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
33 # This will allow you to override all the default values to meet your needs
34 # in a way that won't get clobbered when you pull updates from my GIT repo.
35 ##############################################################################
36 config="${0%/*}/rip_dvd.conf"
37 [ -e "${config}.dist" ] && . ${config}.dist
38 [ -e "${config}" ] && . ${config}
39
40 ##############################################################################################
41 # Command line processing
42 ##############################################################################################
43 typeset cmd="$0 $*"
44 typeset dvdname=""
45 typeset debug=""
46 typeset dest=""
47 typeset isofile=""
48 typeset vobfile=""
49 typeset dvdpath=""
50 typeset aspect=""
51 typeset SCALE=""
52 typeset CROP=""
53 typeset profile="xvidvhq"
54 typeset extension=""
55 typeset -i force_onepass_mode=0
56 typeset -i eject_disk=1
57 typeset -i keep_isofile=0
58 typeset -i keep_vobfile=0
59 typeset -i keep_dvdfolder=0
60 typeset -i keep_intermediate_files=0
61 typeset -i make_final_dest_vob=0
62 typeset -i make_final_dest_iso=0
63 typeset -i make_final_dest_folder=0
64 typeset -i make_final_dest_comp=0
65 typeset -i errors=0
66 typeset -i show_usage=0
67 typeset -i mirror_mode=0
68 typeset -i target_bitrate=2000
69 typeset -i target_size=0
70 typeset -i audio_2ch=0
71 typeset -i invalid_feature_title=0
72 typeset -i feature_title_override=0
73 typeset -i mplayer_dumpstream_incompatibility=0
74
75 while (($#)) && getopts 12mvifkxht:n:d:b:s:t:a:p:e:j: opt "$@"
76 do
77     case $opt in
78         (n)     dvdname=$OPTARG;;
79         (d)     dest=$OPTARG;;
80         (b)     target_bitrate=$OPTARG;;
81         (s)     target_size=$OPTARG;;
82         (2)     audio_2ch=1;;
83         (1)     force_onepass_mode=1;;
84         (v)     make_final_dest_vob=1;;
85         (i)     make_final_dest_iso=1;;
86         (f)     make_final_dest_folder=1;; 
87         (x)     make_final_dest_comp=1;;
88         (m)     mirror_mode=1;;
89         (k)     keep_intermediate_files=1;;
90         (t)     feature_title_override=$OPTARG;;
91         (a)     aspect=$OPTARG;;
92         (p)     profile=$OPTARG;;
93         (e)     extension=$OPTARG;;
94         (j)     eject_disk=$OPTARG;;
95         (w)     set -$opt;;
96         (h)     show_usage=1;;
97         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
98         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
99     esac
100 done
101
102 shift $((OPTIND-1))
103
104 function usage() {
105     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
106     echo >&2 "Revision $REV"
107     echo >&2 "Options:"
108     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
109     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
110     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
111     echo >&2 "                 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
112     echo >&2 "                 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
113     echo >&2 "                 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
114     echo >&2 "                 5) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
115     echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
116     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding (default)"
117     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding"
118     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
119     #echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
120     #echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
121     #echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
122     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
123     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
124     echo >&2 "   -e <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
125     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
126     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
127     echo >&2 "                 The default operation is non-mirror mode where only the main"
128     echo >&2 "                 feature title will be ripped."
129     echo >&2 "   -v            Make the final image a DVD VOB file"
130     echo >&2 "   -i            Make the final image a DVD ISO file"
131     echo >&2 "   -f            Make the final image a DVD folder"
132     echo >&2 "   -x            Make the final image a compressed file based on your profile selection"
133     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
134     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
135     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
136     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
137     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
138     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
139     echo >&2 "   -j <n>        Eject the disk:"
140     echo >&2 "                 - 0 = do not eject the disk"
141     echo >&2 "                 - 1 = eject after the entire script is done (default)"
142     echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
143     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
144     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
145     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
146     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
147     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
148     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
149     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
150     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
151     echo >&2 ""
152     exit 2
153 }
154
155 if (($errors)) || (($show_usage))
156 then
157   usage
158 fi
159
160 # Sanity Check - Command Line Options 
161 if [ "$dest" == "" ]; then
162   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
163   usage
164 fi
165
166 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
167   echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
168   usage
169 fi
170
171 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
172   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
173   usage
174 fi
175
176 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
177    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
178   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
179   usage
180 fi
181
182 if [ $mirror_mode -eq 1 ]; then
183   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
184      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
185     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
186     usage
187   fi
188 fi
189
190 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
191 if [ "$aspect" != "" ]; then
192   echo "$aspect" | grep -q "x"
193   if [ $? == 0 ]; then
194     echo "-E- You must specify the aspect option with a value whose format is W:H"
195     exit 1
196   fi
197   echo "$aspect" | grep -q ":"
198   if [ $? != 0 ]; then
199     SCALE=",scale -zoom -sws 9 -xy $aspect"
200   else
201     SCALE=",scale=$aspect"
202   fi
203 fi
204
205
206 # Sanity Check - Key executables
207 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
208 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
209 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
210 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
211 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
212 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
213 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
214 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
215
216 ##############################################################################################
217
218 typeset -i ripdvd
219 if [ -z "$dvdname" ]; then
220   # make sure the DVD device is accessible
221   volname $dev > /dev/null 2>&1
222   if [ $? != 0 ]; then
223     echo "-E- Can't access the DVD device $dev"
224     exit 1
225   fi
226   # now capture the volume name from the device
227   dvdname=`volname $dev | awk '{ print $1 }'`
228   ripdvd=1
229 else 
230   # check to see if dvdname is a full path to a real directory
231   # if it is, set dvdname and dvdpath appropriately
232   if [ -d "$dvdname" ]; then
233     dvdpath="$dvdname"
234     dvdname=`basename "$dvdname"`
235     keep_dvdfolder=1
236     if [ -z "$dvdname" ]; then
237      echo "-E- Unable to extract dvdname from path: $dvdpath"
238      exit 1
239     fi
240     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
241       echo "-E- You must supply a full path to a valid DVD folder with this option"
242       exit 1
243     fi
244   fi
245
246   # Check to see if dvdname is a full path to a file
247   if [ -f "$dvdname" ]; then
248     valid_file=0
249
250     # check to see if dvdname is a full path to an MPG2 (VOB) file
251     # if it is, set dvdname and vobfile appropriately
252     file "$dvdname" | grep -q "MPEG"
253     if [ $? == 0 ]; then
254       # It is a valid MPEG2 file, now strip the extension off our dvdname
255       vobfile="$dvdname"
256       dvdname=`basename "$dvdname"`
257       dvdname=${dvdname%.[^.]*}
258       keep_vobfile=1
259       valid_file=1
260     fi
261
262     # check to see if dvdname is a full path to an ISO file
263     # if it is, set dvdname and isofile appropriately
264     file "$dvdname" | grep -q -e "ISO" -e "UDF"
265     if [ $? == 0 ]; then
266       # It is a valid ISO file, now strip the extension off our dvdname
267       isofile="$dvdname"
268       dvdname=`basename "$dvdname"`
269       dvdname=${dvdname%.[^.]*}
270       keep_isofile=1
271       valid_file=1
272     fi    
273
274     # If we didn't find a handler for the file above, complain
275     if [ $valid_file -eq 0 ]; then
276       echo "-E- Unsupported file type: $vobfile"
277       exit 1
278     fi
279   fi
280   ripdvd=0
281   # Since we aren't ripping a DVD disk, don't eject anything
282   eject_disk=0
283 fi
284
285 # remove bad characters from the dvdname
286 dvdname=${dvdname%.} # remove trailing '.' character
287
288 # add the suffix extension to the end of the dvdname
289 dvdname=$dvdname$extension
290
291 # make a "safe" dvdname (remove special characters)
292 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
293
294 # Make sure we have a non-empty dvdname
295 if [ -z "$dvdname" ]; then
296   echo "-E- unable to determine dvdname"
297   exit 1
298 fi
299
300 # make sure our vobfile value is set
301 if [ -z "$vobfile" ]; then
302   vobfile="$dest/$dvdname.VOB"
303 fi
304
305 # set up some variables to hold various logfiles
306 logfile="$logdir/$dvdname.log"
307 passlogfile="$tmpdir/$safedvdname.log"
308 ddrescuelog=`tempfile`
309 dvdauthorlog=`tempfile`
310 encodelog=`tempfile`
311 dumplog=`tempfile`
312
313 # create the tmpdir if it doesn't already exist
314 if [ ! -d "$tmpdir" ]; then
315   mkdir -p "$tmpdir"
316   if [ $? != 0 ]; then
317     echo "-E- Unable to create the tmpdir: $tmpdir"
318     exit 1
319   fi
320 fi
321
322 # create the logdir if it doesn't already exist
323 if [ ! -d "$logdir" ]; then
324   mkdir -p "$logdir"
325   if [ $? != 0 ]; then
326     echo "-E- Unable to create the logdir: $logdir"
327     exit 1
328   fi
329 fi
330
331 ##############################################################################################
332 # cleanup functions
333 ##############################################################################################
334 cleanup() { 
335   if [ $keep_intermediate_files -eq 0 ]; then
336     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
337     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
338     [[ -e "$encodelog" ]] && rm -f "$encodelog"
339     [[ -e "$dumplog" ]] && rm -f "$dumplog"
340   else
341     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
342     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
343     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
344     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
345   fi
346   echo ""
347 }
348
349 fatal_and_exit() {
350   if [[ -z "$1" ]]; then
351     msg="-E- control-c killed us"
352   else
353     msg=$1
354   fi
355   echo -e 2>&1 "$msg" | tee -a "$logfile"
356   if [[ -n "$mailto" ]]; then
357     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
358   fi
359   keep_intermediate_files=1
360   exit 1
361 }
362
363 # Call our cleanup functions on INT and EXIT signals
364 trap fatal_and_exit INT
365 trap cleanup EXIT
366
367 ##############################################################################################
368 # processing functions
369 ##############################################################################################
370
371 # encode the vob file into a compressed file format
372 function encode_vob_file {
373
374   # Set a variable that we will use later to determine if we found a handler for $profile or not
375   typeset -i found_profile=0
376
377   # For a given profile, to override the 2 pass behavior to be single pass,
378   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
379   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
380   PASSES="1 2"
381
382   # Declare our default 2 pass variables
383   passlogfile_opt="-passlogfile $passlogfile"
384   pass_opt="pass=%PASS"
385
386   # Check the global force_onepass_mode. If it is set, change our variables appropriately
387   # to force 1-pass encoding across all profiles.
388   if [ $force_onepass_mode -eq 1 ]; then
389     PASSES="2"
390     passlogfile_opt=""
391     pass_opt=""    
392   fi
393
394   # XVID profile
395   if [ "$profile" == "xvid" ] || [ "$profile" == "xvidhq" ] || [ "$profile" == "xvidvhq" ]; then
396     found_profile=1
397     final_output_file="$dest/$dvdname.avi"
398     mencoder_general_opts="$lang_opts $passlogfile_opt"
399     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
400     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
401     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
402
403     # Very High Quality (16fps)
404     if [ "$profile" == "xvidvhq" ]; then
405       video_encoder_opts[0]="bitrate=$target_bitrate"
406       video_encoder_opts[1]="threads=$mencoder_threads"
407       video_encoder_opts[2]="chroma_opt"
408       video_encoder_opts[3]="vhq=4"
409       video_encoder_opts[4]="bvhq=1"
410       video_encoder_opts[5]="quant_type=mpeg"
411       video_encoder_opts[6]="autoaspect"
412     fi
413     # High Quality (20fps)
414     if [ "$profile" == "xvidhq" ]; then
415       video_encoder_opts[0]="bitrate=$target_bitrate"
416       video_encoder_opts[1]="threads=$mencoder_threads"
417       video_encoder_opts[2]="chroma_opt"
418       video_encoder_opts[3]="vhq=2"
419       video_encoder_opts[4]="bvhq=1"
420       video_encoder_opts[5]="quant_type=mpeg"
421       video_encoder_opts[6]="autoaspect"
422     fi
423     # Fast (28fps)
424     if [ "$profile" == "xvid" ]; then
425       video_encoder_opts[0]="bitrate=$target_bitrate"
426       video_encoder_opts[1]="threads=$mencoder_threads"
427       video_encoder_opts[2]="vhq=0"
428       video_encoder_opts[3]="turbo"
429       video_encoder_opts[4]="autoaspect"
430     fi
431
432     for OPTS in "${video_encoder_opts[@]}"; do 
433       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
434     done
435
436     if [ $audio_2ch -eq 0 ]; then
437       # These options produce good 6 channel audio for linux and windows
438       mencoder_audio_opts="-oac copy"
439       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
440       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
441       mencoder_audioch_opts[1]="-af channels=6"
442       mencoder_audioch_opts[2]=""
443     else
444       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
445       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
446       mencoder_audioch_opts[0]=""
447     fi
448  
449   fi
450
451   # MP4 encoding profiles
452   if [ "$profile" == "mp4" ] || [ "$profile" == "mp4hq" ] || [ "$profile" == "mp4vhq" ]; then
453     found_profile=1
454     final_output_file="$dest/$dvdname.mp4"
455     mencoder_general_opts="$lang_opts $passlogfile_opt"
456     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
457     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
458     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
459
460     # Very High Quality (6fps)
461     if [ "$profile" == "mp4vhq" ]; then
462       video_encoder_opts[0]="bitrate=$target_bitrate"
463       video_encoder_opts[1]="threads=$mencoder_threads"
464       video_encoder_opts[2]="subq=6"
465       video_encoder_opts[3]="frameref=5"
466       video_encoder_opts[4]="bframes=3"
467       video_encoder_opts[5]="8x8dct"
468       video_encoder_opts[6]="me=umh"
469       video_encoder_opts[7]="b_pyramid"
470       video_encoder_opts[8]="weight_b"
471       video_encoder_opts[9]="partitions=all" 
472     fi
473     # High Quality (13fps)
474     if [ "$profile" == "mp4hq" ]; then
475       video_encoder_opts[0]="bitrate=$target_bitrate"
476       video_encoder_opts[1]="threads=$mencoder_threads"
477       video_encoder_opts[2]="subq=5"
478       video_encoder_opts[3]="frameref=2"
479       video_encoder_opts[4]="bframes=3"
480       video_encoder_opts[5]="8x8dct"
481       video_encoder_opts[6]="b_pyramid"
482       video_encoder_opts[7]="weight_b"
483     fi
484     # Fast (17fps)
485     if [ "$profile" == "mp4" ]; then
486       video_encoder_opts[0]="bitrate=$target_bitrate"
487       video_encoder_opts[1]="threads=$mencoder_threads"
488       video_encoder_opts[2]="subq=4"
489       video_encoder_opts[3]="bframes=2"
490       video_encoder_opts[4]="b_pyramid"
491       video_encoder_opts[5]="weight_b"
492     fi
493
494     for OPTS in "${video_encoder_opts[@]}"; do
495       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
496     done
497
498     if [ $audio_2ch -eq 0 ]; then
499       # These options produce good 6 channel audio for linux and windows
500       #mencoder_audio_opts="-oac copy"
501       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
502       #mencoder_audioch_opts[0]="-channels 6 -af channels=6"
503       #mencoder_audioch_opts[1]="-af channels=6"
504       #mencoder_audioch_opts[2]=""
505       mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
506       mencoder_audioch_opts[0]="-channels 6 -srate 48000"
507     else
508       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
509       #mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
510       #mencoder_audioch_opts[0]=""
511       mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
512       mencoder_audioch_opts[0]="-channels 2 -srate 48000"
513     fi
514
515   fi
516
517   # iphone and ipod MP4 profiles
518   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
519     found_profile=1
520     if [ "$profile" == "iphone" ]; then
521       # SCALE: 480x320
522       # scale width to 480, set height appropriately, but keep a multiple of 16
523       #SCALE=",scale=480:-10"
524       # scale the video down however far is necessary to fit in 480x320
525       SCALE=",dsize=480:320:0,scale=-8:-8"
526     else
527       # SCALE: 320x240
528       # scale width to 320, set height appropriately, but keep a multiple of 16
529       #SCALE=",scale=320:-10"
530       # scale the video down however far is necessary to fit in 320x240
531       SCALE=",dsize=320:240:0,scale=-8:-8"
532     fi
533     final_output_file="$dest/$dvdname.mp4"
534     mencoder_general_opts="$lang_opts $passlogfile_opt"
535     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
536     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
537     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
538     video_encoder_opts[0]="bitrate=$target_bitrate"
539     video_encoder_opts[1]="threads=$mencoder_threads"
540     video_encoder_opts[2]="vbv_maxrate=1500"
541     video_encoder_opts[3]="vbv_bufsize=2000"
542     video_encoder_opts[4]="nocabac"
543     video_encoder_opts[5]="me=umh"
544     video_encoder_opts[6]="subq=6"
545     video_encoder_opts[7]="frameref=6"
546     video_encoder_opts[8]="trellis=1"
547     video_encoder_opts[9]="level_idc=30"
548     video_encoder_opts[10]="global_header"
549     video_encoder_opts[11]="bframes=0"
550     video_encoder_opts[12]="partitions=all"
551     for OPTS in "${video_encoder_opts[@]}"; do 
552       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
553     done
554
555     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
556     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
557   fi
558
559   if [ $found_profile -eq 0 ]; then
560     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
561   fi
562
563   # Do not edit this line. $mencoder_video_encoder_opts must be last
564   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
565   mencoder_retval=0
566
567   for PASS in $PASSES
568   do 
569     # Set some options based on which pass we are in
570     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
571     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
572     [ $PASS -eq 1 ] && output_file="/dev/null"
573     [ $PASS -eq 2 ] && output_file="$final_output_file"
574   
575     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
576     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
577     do
578       echo -e "   Encoding pass $PASS"
579       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
580       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
581       mencoder_retval=$? 
582       grep -q "\[channels\] Invalid" $encodelog
583       if [ $? != 0 ]; then          
584         break;
585       else
586         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
587       fi
588     done
589       
590     if [ $mencoder_retval != 0 ]; then
591       fatal_and_exit "-E- Unhandled mencoder error"
592     fi
593
594     # Concatenate the encode log to our main log file, greping out unwanted lines
595     cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
596
597   done
598 }
599
600 function make_dvd_iso_image {
601
602   isofile="$1"
603
604   # check to see if we have a dvdpath to rip from instead of $dev
605   if [ -z "$dvdpath" ]; then
606     # load the CSS codes in the DVD drive 
607     lsdvd $dev >> "$logfile"
608     if [ $? != 0 ]; then
609       fatal_and_exit "-E- lsdvd $dev failed" 
610     fi
611
612     # read the DVD, ignoring/skipping CRC errors
613     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
614     if [ $? != 0 ]; then
615       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
616     fi
617     cat "$ddrescuelog" >> "$logfile"
618   else
619     # rip from a path instead
620     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
621   fi
622 }
623
624 function make_dvd_iso_image_from_folder {
625   
626   src="$1"
627   dst="$2"
628   handle_error=$3
629   
630   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
631
632   # make an iso image out of our directory
633   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
634   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
635
636   # set the audio languages from the iso if it exists and is non-zero in size
637   if [ -s "$dst" ]; then
638     get_feature_title "$dst"
639     get_audio_id_from_iso "$dst"
640   fi
641
642   # make sure we were able to create the iso image from the folder given to us
643   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
644     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
645     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
646     # remove the bad iso file
647     [[ -e "$dst" ]] && rm -f "$dst"
648     # get the feature title from the DVD folder
649     get_feature_title "$dvdpath"
650     # create our main VOB file from the ISO
651     create_main_vob_with_mplayer "$dvdpath" 
652     # get our audio id from the VOB file
653     get_audio_id_from_vob "$vobfile"
654   fi
655 }
656
657 function make_dvdbackup_folder_image {
658   # extract the feature title from the DVD image
659   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
660   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
661   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
662   if [ $? != 0 ]; then
663     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
664   fi
665 }
666
667 function make_dvdauthor_folder_image {
668   # create a new DVD video of the feature title
669   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
670   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
671   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
672   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
673
674   # There is a chance that dvdauthor won't like some of the VOBs.
675   # We can't tell ahead of time which ones it will choke on. 
676   # So, we need to run it over and over again until it can process
677   # all the VOBs. If it can't handle one of them, run it through
678   # mencoder to fix it and try again. These errors are typically
679   # present due to the copy protection that ddrescue removed.
680   grep -q "SCR moves" $dvdauthorlog
681   while [ $? == 0 ]; do
682     # fix bad vobs that get the "SCR moves backwards" error:
683     #  STAT: Processing VTS_01_0.VOB...
684     #  ERR:  SCR moves backwards, remultiplex input.
685     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
686     if [[ ! -f "$badvob" ]]; then
687       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
688     fi
689     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
690     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
691     mv -f $badvob.fixed $badvob
692     echo "-> Creating DVD video $dest/$dvdname"
693     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
694     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
695     grep -q "SCR moves" $dvdauthorlog
696   done
697 }
698
699 function get_feature_title {
700   source="$1"
701   # if a feature title was given on the command line, use it
702   if [ $feature_title_override -ne 0 ]; then
703     feature_title=$feature_title_override
704     return 0
705   fi
706   # otherwise, use lsdvd to figure it out
707   if [ $ripdvd -eq 1 ]; then
708     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
709   else 
710     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
711   fi
712 }
713
714 function create_main_vob_with_cat {
715   # cd to the feature title DVD folder
716   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
717   if [ $? != 0 ]; then
718     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
719   fi
720
721   # concatenate all the VOBs together into 1 giant VOB
722   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
723   cat $vobs > "$tmpdir/$dvdname.VOB"
724
725   # cd back to the dir we started from
726   popd > /dev/null 2>&1
727 }
728
729 function create_main_vob_with_mplayer {
730
731   # argument processing  
732   source="$1"
733   remove_dumplog=$2
734
735   # make sure we have a valid feature title
736   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
737     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
738   fi
739
740   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
741   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
742     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
743     msg="$msg We also detected another condition that requires us to use dumpstream. "
744     msg="$msg\n    Unable to rip this DVD in the mode you requested."
745     fatal_and_exit "$msg"
746   fi
747
748   # use mplayer to create the main VOB file
749   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
750   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
751   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
752   if [ $? != 0 ]; then
753     cat $dumplog | grep -v "^A:" >> "$logfile"
754     fatal_and_exit "-E- Mplayer Failed"
755   fi
756   cat $dumplog | grep -v "^A:" >> "$logfile"
757   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
758 }
759
760 function get_audio_id_from_iso {
761   # Adjust our audio ID to find the english audio stream
762   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
763   iso="$1"
764   aidcheck=`tempfile`
765   aid=128
766   mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
767   grep -q "aid: $aid" $aidcheck
768   while [ $? == 1 ] && [ $aid -lt 159 ]; do
769     (( aid = aid + 1 ))
770     grep -q "aid: $aid" $aidcheck
771   done
772   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
773   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
774   # mencoder default DVD audio track language selection (english)
775   lang_opts="-aid $aid -alang en"
776 }
777
778 function get_crop_from_iso { 
779   FRAMES=10000
780   echo "-> Detecting black frame border crop value from ISO file"
781   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
782   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
783   [[ -e "md5sums" ]] && rm -f "md5sums"
784   CROP=`cat $dumplog | grep CROP | tail -1`
785   echo "   Found crop value of $CROP" >> "$logfile"
786   CROP=${CROP#* crop=}
787   CROP=${CROP%%\).*}
788   typeset -i CROPCHECK
789   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
790   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
791   if [ -z "$CROP" ]; then
792     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
793     return
794   fi
795   if [ $CROPCHECK -lt 0 ]; then 
796     CROP=""
797   else 
798     CROP=",crop=$CROP"
799   fi
800   echo "   Setting mencoder crop filter to: $CROP"
801 }
802
803 function get_crop_from_vob { 
804   FRAMES=10000
805   echo "-> Detecting black frame border crop value from VOB file"
806   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
807   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
808   [[ -e "md5sums" ]] && rm -f "md5sums"
809   CROP=`cat $dumplog | grep CROP | tail -1`
810   echo "   Found crop value of $CROP" >> "$logfile"
811   CROP=${CROP#* crop=}
812   CROP=${CROP%%\).*}
813   typeset -i CROPCHECK
814   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
815   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
816   if [ -z "$CROP" ]; then
817     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
818     return
819   fi
820   if [ $CROPCHECK -lt 0 ]; then 
821     CROP=""
822   else 
823     CROP=",crop=$CROP"
824   fi
825   echo "   Setting mencoder crop filter to: $CROP"
826 }
827
828 function get_audio_id_from_vob {
829   # Adjust our audio ID to find the english audio stream
830   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
831   vob="$1"
832   aidcheck=`tempfile`
833   aid=128
834   mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
835   grep -q "Found audio stream: $aid" $aidcheck
836   while [ $? == 1 ] && [ $aid -lt 159 ]; do
837     (( aid = aid + 1 ))
838     grep -q "Found audio stream: $aid" $aidcheck
839   done
840   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
841   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
842   # mencoder default DVD audio track language selection (english)
843   lang_opts="-aid $aid -alang en"
844 }
845
846 function check_vob_for_corrupted_start {
847   # check to see if the beginning of the DVD has a form of copy protection
848   # where they have deliberately broken the first X number of frames of the DVD.
849   # If we don't skip these, our resulting VOB file will not play.
850   badvobcheck=`tempfile`
851   endpos=360
852   skip=0
853   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
854   if [ $? != 0 ]; then
855     fatal_and_exit "-E- Mencoder Failed"
856   fi
857   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
858   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
859     (( skip = skip + 5 ))
860     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
861     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
862     if [ $? != 0 ]; then
863       fatal_and_exit "-E- Mencoder Failed"
864     fi
865     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
866   done
867   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
868
869   # cat the giant VOB into mencoder to create a playable VOB file
870   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
871   if [ $? != 0 ]; then
872     fatal_and_exit "-E- Mencoder Failed"
873   fi
874 }
875
876 function check_vob_for_completeness {
877   # check to make sure we got out a complete VOB.
878   # there is another kind of copy protection where the VOB's may
879   # have "MPG EOF" frames in the middle of the stream. 
880   # this causes mencoder to not process the entire VOB, and exit without any errors.
881   # detect this by seeing how much smaller the dst vob is from the src vob.
882   MAX_FILESIZE_DELTA_PERCENT=70
883   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
884   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
885   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
886   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
887     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
888     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
889     create_main_vob_with_mplayer "$isofile"
890     [[ -e "$dumplog" ]] && rm -f $dumplog
891     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
892     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
893     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
894       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
895     fi
896   fi
897 }
898
899 function check_vob_for_too_many_video_packets {
900   # If our earlier algorithm to work around this failed, throw an error.
901   # check to see if this DVD has a protection scheme we don't know how to work around
902   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
903   # for some reason, the video is black, while the audio rolls, then the video finally comes
904   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
905   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
906   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
907   grep -q "Too many video packets in the buffer:" "$logfile"
908   if [ $? == 0 ]; then
909     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
910     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
911     create_main_vob_with_mplayer "$isofile"
912     grep -q "Too many video packets in the buffer:" $dumplog
913     if [ $? == 0 ]; then
914       [[ -e "$dumplog" ]] && rm -f $dumplog
915       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
916     fi
917     [[ -e "$dumplog" ]] && rm -f $dumplog
918   fi
919 }
920
921 function check_vob_for_a52_crc_errors {
922   # Let's see if we can playback our newly created VOB file without any errors.
923   # if there are issues, let's detect them now, and try to recreate the VOB
924   # there are some forms of copy protection that have missed above, that evidence
925   # themselves when we try to playback the VOB file. This was added to deal with
926   # the "a52: CRC check failed" copy protection scheme.
927   MAX_ERRORS=10
928   ENDPOS=120
929   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
930   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
931   cat $dumplog | grep -v "^A:" >> "$logfile"
932   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
933   if [ $errors -gt $MAX_ERRORS ]; then
934     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
935     create_main_vob_with_mplayer "$isofile"
936     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
937     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
938     if [ $? != 0 ]; then
939       cat $dumplog | grep -v "^A:" >> "$logfile"
940       fatal_and_exit "-E- Mplayer Failed"
941     fi
942     cat $dumplog | grep -v "^A:" >> "$logfile"
943     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
944     if [ $errors -gt $MAX_ERRORS ]; then
945       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
946     fi
947   fi
948   [[ -e "$dumplog" ]] && rm -f $dumplog
949 }
950
951 function calculate_bitrate_from_target_size {
952   # determine what our bitrate needs to be if a target size was specified instead
953   if [ $target_size -ne 0 ]; then
954     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
955     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
956     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
957   fi
958 }
959
960 function create_dvdauthor_dvd_xml_file {
961   # make a dvdauthor xml menu file to create a valid DVD video from 
962   # this script does a good job, but we'll still need to clean it up a bit after it runs
963   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
964   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
965   if [ $? != 0 ]; then
966     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
967   fi
968
969   # replace the first line of the xml file to remove the bad dest path
970   awk -v line=1 -v new_content="<dvdauthor>" '{
971     if (NR == line) {
972       print new_content;
973     } else {
974       print $0;
975     }
976   }' dvd.xml > dvd.xml.new
977   mv -f dvd.xml.new dvd.xml
978   if [ $? != 0 ]; then
979     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
980   fi
981
982   # remove the "<video " property line from the xml file
983   cat dvd.xml | grep -v "<video" > dvd.xml.new
984   mv -f dvd.xml.new dvd.xml
985   if [ $? != 0 ]; then
986     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
987   fi
988   
989   # remove the extra <pgc>..</pgc> pairs
990   cat dvd.xml | awk 'BEGIN {x=1}
991   {
992     if ($0~"</pgc>") {x=0}
993     if (x==1) {print $0}
994     if ($0~"<pgc>") {x=1}
995   }' > dvd.xml.new
996   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
997   mv -f dvd.xml.new dvd.xml
998   if [ $? != 0 ]; then
999     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1000   fi
1001
1002   # remove the VTS_*_0.VOB file as this is just the main menu video clip
1003   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1004   mv -f dvd.xml.new dvd.xml
1005   if [ $? != 0 ]; then
1006     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1007   fi
1008 }
1009
1010 function check_for_mplayer_dumpstream_incompatibility {
1011
1012   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1013
1014   if [ ! -e "$vobfile" ]; then
1015     # mplayer dumpstream does not work on DVDs that obscure the feature title.
1016     # A DVD that has 99 titles, where the longest title isn't the main feature
1017     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1018     # out what the feature title is. This script will run through that flow if we
1019     # set use_mplayer_dumpstream to 0. Check for this here.
1020     if [ $ripdvd -eq 1 ]; then
1021       lsdvd $dev | grep -q "Title: 99"
1022     else
1023       lsdvd "$isofile" | grep -q "Title: 99"
1024     fi
1025     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1026     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1027       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1028         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1029         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1030         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1031         invalid_feature_title=1
1032       else 
1033         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1034         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1035         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1036         use_mplayer_dumpstream=0
1037         invalid_feature_title=1
1038       fi
1039       return
1040     fi
1041   fi
1042
1043   # There is another form of protection that causes the mplayer dumpstream to fail. 
1044   # This can be detected by telling mplayer to parse the VOB file by copying its audio
1045   # video streams to a dummy output file (/dev/null). Do that here to check for that 
1046   # problem before continuing.
1047   if [ -e "$vobfile" ]; then
1048     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1049     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1050     grep -q "Too many audio packets in the buffer" $dumplog
1051     if [ $? == 0 ]; then
1052       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1053       use_mplayer_dumpstream=0
1054       mplayer_dumpstream_incompatibility=1
1055     fi
1056     [[ -e "$dumplog" ]] && rm -f $dumplog
1057   fi
1058 }
1059
1060 function fill_mythvideo_metadata {
1061
1062   # This function must be passed the filename as an argument
1063   # The filename must be a full path to the file
1064   filename="$1"
1065
1066   # Make sure the fill mythvideo metadata option has been set to 1
1067   if [ $fill_mythvideo_metadata -eq 0 ]; then
1068     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1069     return 0
1070   fi
1071
1072   # If the fill mythvideo metadata script is present, run it
1073   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1074   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1075     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1076     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1077   else
1078     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1079     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1080   fi
1081 }
1082
1083 # remove the intermediate VOB file
1084 function remove_intermediate_vob_file {
1085   if [ $keep_intermediate_files -eq 0 ]; then
1086     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1087   else
1088     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1089   fi
1090 }
1091
1092 # remove the original DVD image 
1093 function remove_intermediate_iso_file {
1094   [[ $keep_isofile -eq 1 ]] && return 1
1095   if [ $keep_intermediate_files -eq 0 ]; then
1096     [[ -e "$isofile" ]] && rm "$isofile"
1097   else
1098     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1099   fi
1100 }
1101
1102 # remove the intermediate dvdbackup folder
1103 function remove_intermediate_dvdbackup_folder {
1104   if [ $keep_intermediate_files -eq 0 ]; then
1105     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1106   else
1107     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1108   fi
1109 }
1110
1111 ##############################################################################################
1112 # MAIN
1113 ##############################################################################################
1114
1115 # Make a note of when this DVD rip started
1116 date=`date`
1117 echo -e "\n$date DVD rip started" >> "$logfile"
1118 echo "$cmd" >> "$logfile"
1119
1120 # Rip the DVD - Mirror Mode
1121 if [ $mirror_mode -eq 1 ]; then
1122   echo "-> Ripping DVD $dvdname to $dest"
1123
1124   # use ddrescue to make an ISO image of the disk
1125   make_dvd_iso_image "$dest/$dvdname.iso"
1126
1127   # add this video data to the mythtv DB
1128   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1129
1130   # eject the disk upon completion
1131   if [ $eject_disk -ne 0 ]; then
1132     eject -T $dev
1133   fi
1134
1135   date=`date`
1136   echo "$date DVD rip completed" | tee -a "$logfile"
1137
1138   if [[ -n "$mailto" ]]; then
1139     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1140   fi
1141
1142 fi
1143
1144 # Rip the DVD - Main Title Feature Only
1145 if [ $mirror_mode -eq 0 ]; then
1146
1147   # Rip image from DVD
1148   if [ $ripdvd -eq 1 ]; then
1149     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1150     # use ddrescue to make an ISO image of the disk
1151     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1152   fi
1153
1154   # Rip image from DVD path
1155   if [ -n "$dvdpath" ]; then
1156     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1157     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1158   fi
1159
1160   # make sure our isofile value is set
1161   if [ -z "$isofile" ]; then
1162     isofile="$tmpdir/$dvdname.iso"
1163   fi
1164      
1165   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1166
1167     if [ ! -e "$vobfile" ]; then
1168       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1169       
1170       # get the feature title from the ISO
1171       get_feature_title "$isofile"
1172  
1173       # get the crop value from the ISO
1174       get_crop_from_iso
1175
1176       # check for mplayer dumpstream incompatibilities
1177       # if they exist, this method will set this mode to 0.
1178       check_for_mplayer_dumpstream_incompatibility
1179
1180       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1181
1182         # get our audio id from the ISO file
1183         get_audio_id_from_iso "$isofile"
1184
1185         # create our main VOB file from the ISO
1186         create_main_vob_with_mplayer "$isofile"
1187      
1188         # remove the intermediate VOB file
1189         remove_intermediate_vob_file
1190
1191         # it's possible that our VOB is still corrupted in some manner
1192         # check to make sure it is still a good VOB before continuing.
1193         check_for_mplayer_dumpstream_incompatibility
1194
1195       fi
1196  
1197       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1198
1199         # use dvdbackup to make a DVD folder of the feature title
1200         make_dvdbackup_folder_image
1201   
1202         # create our main VOB file
1203         create_main_vob_with_cat
1204
1205         # get our audio id from the VOB file
1206         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1207   
1208         # check for corrupted VOB start
1209         check_vob_for_corrupted_start
1210  
1211         # check to make sure our VOB is complete
1212         check_vob_for_completeness
1213
1214         # check to make sure our VOB doesn't have too many video packets
1215         check_vob_for_too_many_video_packets
1216
1217         # check to make sure our VOB doesn't have a52 crc errors
1218         check_vob_for_a52_crc_errors
1219
1220         # remove the intermediate VOB file
1221         remove_intermediate_vob_file
1222
1223       fi
1224
1225       # remove the intermediate ISO file
1226       remove_intermediate_iso_file
1227
1228     else
1229       echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1230       # get our audio id from the VOB file
1231       get_audio_id_from_vob "$vobfile"
1232       # get the crop value from the VOB
1233       get_crop_from_vob
1234     fi
1235
1236     # eject the DVD disk since we are finished with it
1237     [ $eject_disk -eq 2 ] && eject -T $dev
1238
1239     # encode the VOB file to a compressed file format
1240     if [ $make_final_dest_comp -eq 1 ]; then
1241       echo "-> Encoding the DVD video to a compressed file" | tee -a "$logfile"
1242
1243       # determine what our bitrate needs to be if a target size was specified instead
1244       calculate_bitrate_from_target_size        
1245      
1246       # encode the vob file into a compressed file format
1247       encode_vob_file
1248
1249       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1250         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1251         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1252       else
1253         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1254         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1255       fi
1256     fi
1257
1258   # add this video data to the mythtv DB
1259   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1260   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1261     
1262   else
1263
1264   # use dvdbackup to make a DVD folder of the feature title
1265   make_dvdbackup_folder_image
1266
1267   # cd to the feature title DVD folder
1268   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1269   if [ $? != 0 ]; then
1270     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1271   fi
1272   
1273   # create the dvd.xml file for dvdauthor
1274   create_dvdauthor_dvd_xml_file  
1275
1276   # make the final DVD folder image
1277   make_dvdauthor_folder_image
1278
1279   # add this video data to the mythtv DB
1280   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1281  
1282   # cd back to the dir we started from
1283   popd > /dev/null 2>&1
1284
1285   if [ $make_final_dest_iso -eq 1 ]; then
1286
1287     # make an iso image out of our directory
1288     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1289    
1290     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1291     if [ -s "$dest/$dvdname.iso" ]; then
1292       if [ $make_final_dest_folder -eq 0 ]; then
1293         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1294         # remove the folder of the DVD image now that we have a .iso version of it
1295         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1296       fi
1297     else
1298       # we created an empty iso file, remove it
1299       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1300       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1301       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1302     fi
1303  
1304     # add this video data to the mythtv DB
1305     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1306
1307   fi
1308
1309   fi
1310
1311   # remove the ddrescue DVD ISO image
1312   remove_intermediate_iso_file
1313
1314   # remove the tmp dvdbackup folder of the DVD image
1315   remove_intermediate_dvdbackup_folder
1316
1317   # eject the DVD disk upon completion
1318   [ $eject_disk -eq 1 ] && eject -T $dev
1319
1320   date=`date`
1321   echo "$date DVD rip completed" | tee -a "$logfile"
1322
1323   if [[ -n "$mailto" ]]; then
1324     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1325   fi
1326
1327 fi
1328
1329 ##############################################################################################